import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private aax;
    get aay(): IAnchoredCategorySeriesInteractionManager;
    aat: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    me(): string;
    protected cs(): SeriesView;
    qz(a: SeriesView): void;
    aa4: boolean;
    constructor();
    abl: string;
    kq(a: any, b: string): any;
    md(a: string): string;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private aaz;
    abd: string;
    abh: string;
    abj: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ab8(): Brush;
    set ab8(a: Brush);
    static readonly abu: DependencyProperty;
    trendLineThickness: number;
    aca: PenLineCap;
    ab9: DoubleCollection;
    trendLinePeriod: number;
    aa8: number;
    gd(a: any): boolean;
    protected aaq(a: number, b: number, c: Axis): any[];
    protected q7(a: any, b: string, c: any, d: any): void;
    ay(a: Axis): AxisRange;
    protected pb(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected zs(): number;
    aa7(a: CategorySeriesView): number;
    abr(a: PointCollection, b: number, c: CategorySeriesView): void;
    aar(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    aas(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected gb(): boolean;
    protected ht(): List$1<SeriesLayerPropertyOverlay>;
    private abn;
    he(a: Rect, b: Rect, c: SeriesView): boolean;
    o5(a: boolean, b: SeriesView): void;
    aaf(a: CategoryFrame, b: CategorySeriesView): void;
    aai(a: CategoryFrame, b: CategorySeriesView): void;
    aau: CategoryFrame;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abo(a: CategoryFrame, b: CategorySeriesView): void;
    protected sf(): void;
    kx(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected abb: string;
    protected aba: string;
    abstract abp(a: Axis): void;
    abstract abq(a: Axis): void;
    protected px(a: any): void;
    aav: CategorySeriesMarkerCollisionAvoidance;
    kn(a: Point): any;
    aaw: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    iy(): number;
    protected get_aa9(): number;
    protected get aa9(): number;
    az(a: Rect): AxisRange;
    private abt;
    private aa1;
    private aa5;
    aa6: number;
    private abs;
    i8(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wd(a: ValueLayerValueMode): Point;
    we(a: number[]): Point;
    aab(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    aa3(a: number, b: number, c: number): boolean;
    aa2(a: number, b: number, c: number): boolean;
    z5(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c5: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c6;
    get c7(): ITrendLineManager;
    set c7(a: ITrendLineManager);
    get c8(): boolean;
    dc(): void;
    da(): void;
    c9(): void;
    cx(): CategoryBucketCalculator;
    db(): void;
    dd(): void;
    de(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
